#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct data {
	int dia;
	int mes;
	int ano;
};
typedef struct data Data;

struct funcionario {
	char nome[60];
	int idade;
	char sexo;
	int cpf;
	Data nascimento;
	int cod;
	char cargo[30];
	float salario;
};
typedef struct funcionario Funcionario;

void preenche (Funcionario *func) {
	printf("Nome:\n");
	scanf (" %[^\n]s", (*func).nome);
	printf("Idade:\n");
	scanf (" %d", &(*func).idade);
	printf("Sexo:\n");
	scanf (" %c", &(*func).sexo);
	printf("CPF:\n");
	scanf (" %d", &(*func).cpf);
	printf("Data de nascimento:\n");
	scanf (" %d", &((*func).nascimento).dia);
	scanf (" %d", &((*func).nascimento).mes);
	scanf (" %d", &((*func).nascimento).ano);
	printf("Codigo:\n");
	scanf (" %d", &(*func).cod);
	printf("Cargo:\n");
	scanf (" %[^\n]s", (*func).cargo);
	printf("Salario:\n");
	scanf (" %f", &(*func).salario);
	printf("\n");
}

void exibe (Funcionario func) {
	printf("%s\n", func.nome);
	printf("%d\n", func.idade);
	printf("%c\n", func.sexo);
	printf("%d\n", func.cpf);
	printf("%d ", (func.nascimento).dia);
	printf("%d ", (func.nascimento).mes);
	printf("%d\n", (func.nascimento).ano);
	printf("%d\n", func.cod);
	printf("%s\n", func.cargo);
	printf("%.2f\n", func.salario);
	printf("\n");
}

void bubleSortIdade (Funcionario *func, int n) {
	Funcionario aux;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if ((func[j].idade) > (func[i].idade)) {
				aux = func[i];
				func[i] = func[j];
				func[j] = aux;
			}
		}
	}
}

void bubleSortCargo (Funcionario *func, int n) {
	Funcionario aux;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (strcmp(func[j].cargo, func[i].cargo) < 0) {
				aux = func[i];
				func[i] = func[j];
				func[j] = aux;
			}
		}
	}
}

int main () {
	Funcionario *func;
	char op;
	int n = 0;
	func = (Funcionario*) malloc (sizeof (Funcionario));
	while (1) {
		printf("Deseja adicionar um novo funcionario?\n");
		printf("S para adicionar\n");
		printf("N para sair\n");
		scanf (" %c", &op);

		if (op == 'S') {
			n ++;
			func = realloc (func, n * sizeof (Funcionario));
			preenche (&func[n - 1]);
		}

		else if (op == 'N') {
			printf("\n\n");
			bubleSortIdade (func, n);
			for (int i = 0; i < n; ++i) exibe (func[i]);
			bubleSortCargo (func, n);
			for (int i = 0; i < n; ++i) exibe (func[i]);
			return 0;
		}

	}
}