#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct carro {
	char marca[15];
	int ano;
	float preco;
};
typedef struct carro Carro;

void preenche (Carro *carro) {
	printf("Entre com os dados do carro:\n");
	scanf (" %[^\n]s", (*carro).marca);
	scanf (" %d", &(*carro).ano);
	scanf (" %f", &(*carro).preco);
	printf("\n");
}

void mostra (Carro *carros, int n, float p) {
	for (int i = 0; i < n; ++i)
	{
		if (carros[i].preco > p) return;
		printf("%s\n", carros[i].marca);
		printf("%d\n", carros[i].ano);
		printf("%.2f\n", carros[i].preco);
		printf("\n");
	}
}

void bubbleSort (Carro *carro, int n) {
	Carro aux;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (carro[j].preco < carro[i].preco) {
				aux = carro[i];
				carro[i] = carro[j];
				carro[j] = aux;
			}
		}
	}
}

int main () {
	int n;
	float p;
	scanf (" %d", &n);
	printf("\n");
	Carro carros[n];
	for (int i = 0; i < n; ++i) preenche (&carros[i]);
	bubbleSort (carros, n);
	while (1) {
		printf("Digite o preco:\n");
		scanf (" %f", &p);
		printf("\n");
		if (p <= 0) return 0;
		mostra (carros, n, p);
	}
}